| OpenCV 5.0.0alpha Open Source Computer Vision

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
cv::Algorithm Class Reference
Core functionality » Basic structures

This is a base class for all more or less complex algorithms in OpenCV. More...

`#include <opencv2/core.hpp>`

Collaboration diagram for cv::Algorithm:

## Public Member Functions
| Algorithm ()
virtual | ~Algorithm ()
virtual void | clear ()
| Clears the algorithm state.
virtual bool | empty () const
| Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read.
virtual String | getDefaultName () const
virtual void | read (const FileNode &fn)
| Reads algorithm parameters from a file storage.
virtual void | save (const String &filename) const
virtual void | write (FileStorage &fs) const
| Stores algorithm parameters in a file storage.
void | write (FileStorage &fs, const String &name) const

## Static Public Member Functions
template<typename _Tp >
static Ptr< _Tp > | load (const String &filename, const String &objname=String())
| Loads algorithm from the file.
template<typename _Tp >
static Ptr< _Tp > | loadFromString (const String &strModel, const String &objname=String())
| Loads algorithm from a String.
template<typename _Tp >
static Ptr< _Tp > | read (const FileNode &fn)
| Reads algorithm from the file node.

## Protected Member Functions
void | writeFormat (FileStorage &fs) const

## Detailed Description

This is a base class for all more or less complex algorithms in OpenCV.

especially for classes of algorithms, for which there can be multiple implementations. The examples are stereo correspondence (for which there are algorithms like block matching, semi-global block matching, graph-cut etc.), background subtraction (which can be done using mixture-of-gaussians models, codebook-based algorithm etc.), optical flow (block matching, Lucas-Kanade, Horn-Schunck etc.).

Here is example of SimpleBlobDetector use in your application via Algorithm interface:

Ptr<Feature2D> sbd = SimpleBlobDetector::create();
FileStorage fs_read("SimpleBlobDetector_params.xml", FileStorage::READ);
if (fs_read.isOpened()) // if we have file with parameters, read them
{
sbd->read(fs_read.root());
fs_read.release();
}
else // else modify the parameters and store them; user can later edit the file to use different parameters
{
fs_read.release();
FileStorage fs_write("SimpleBlobDetector_params.xml", FileStorage::WRITE);
sbd->write(fs_write);
fs_write.release();
}
Mat result, image = imread("../data/detect_blob.png", IMREAD_COLOR);
vector<KeyPoint> keypoints;
sbd->detect(image, keypoints, Mat());
drawKeypoints(image, keypoints, result);
for (vector<KeyPoint>::iterator k = keypoints.begin(); k != keypoints.end(); ++k)
circle(result, k->pt, (int)k->size, Scalar(0, 0, 255), 2);
imshow("result", result);
waitKey(0);

## Constructor & Destructor Documentation

## ◆ Algorithm()

cv::Algorithm::Algorithm | ( |  | ) |

## ◆ ~Algorithm()

virtual cv::Algorithm::~Algorithm | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ clear()

virtual void cv::Algorithm::clear | ( |  | ) |
| inline virtual

Python:
| cv.Algorithm.clear( |  | ) -> | None

Clears the algorithm state.

Reimplemented in cv::cuda::DescriptorMatcher, cv::DescriptorMatcher, cv::FlannBasedMatcher, cv::line_descriptor::BinaryDescriptorMatcher, cv::quality::QualityBase, cv::quality::QualityGMSD, cv::quality::QualityMSE, cv::quality::QualityPSNR, and cv::quality::QualitySSIM.

## ◆ empty()

virtual bool cv::Algorithm::empty | ( |  | ) | const
| inline virtual

Python:
| cv.Algorithm.empty( |  | ) -> | retval

Returns true if the Algorithm is empty (e.g. in the very beginning or after unsuccessful read.

Reimplemented in cv::BaseCascadeClassifier, cv::cuda::DescriptorMatcher, cv::DescriptorMatcher, cv::face::BasicFaceRecognizer, cv::face::FaceRecognizer, cv::Feature2D, cv::ml::StatModel, cv::quality::QualityBase, cv::quality::QualityGMSD, cv::quality::QualityMSE, cv::quality::QualityPSNR, and cv::quality::QualitySSIM.

## ◆ getDefaultName()

virtual String cv::Algorithm::getDefaultName | ( |  | ) | const
| virtual

Python:
| cv.Algorithm.getDefaultName( |  | ) -> | retval

Returns the algorithm string identifier. This string is used as top level xml/yml node tag when the object is saved to a file or string.

Reimplemented in cv::AffineFeature, cv::FastFeatureDetector, cv::Feature2D, cv::GFTTDetector, cv::MSER, cv::ORB, cv::SIFT, cv::SimpleBlobDetector, cv::xfeatures2d::AgastFeatureDetector, cv::xfeatures2d::AKAZE, cv::xfeatures2d::BEBLID, cv::xfeatures2d::BoostDesc, cv::xfeatures2d::BriefDescriptorExtractor, cv::xfeatures2d::BRISK, cv::xfeatures2d::DAISY, cv::xfeatures2d::FREAK, cv::xfeatures2d::HarrisLaplaceFeatureDetector, cv::xfeatures2d::KAZE, cv::xfeatures2d::LATCH, cv::xfeatures2d::LUCID, cv::xfeatures2d::MSDDetector, cv::xfeatures2d::StarDetector, cv::xfeatures2d::SURF, cv::xfeatures2d::TBMR, cv::xfeatures2d::TEBLID, and cv::xfeatures2d::VGG.

## ◆ load()

template<typename _Tp >

static Ptr< _Tp > cv::Algorithm::load | ( | const String & | filename,
|  | const String & | objname = String() )
| inline static

Loads algorithm from the file.

Parameters

  filename | Name of the file to read.
  objname | The optional name of the node to read (if empty, the first top-level node will be used)

This is static template method of Algorithm. It's usage is following (in the case of SVM):

Ptr<SVM> svm = Algorithm::load<SVM>("my_svm_model.xml");
cv::Algorithm::load
static Ptr< _Tp > load(const String &filename, const String &objname=String())
Loads algorithm from the file.
Definition core.hpp:3194
cv::Ptr
std::shared_ptr< _Tp > Ptr
Definition cvstd_wrapper.hpp:23

In order to make this method work, the derived class must overwrite Algorithm::read(const FileNode& fn).

Here is the call graph for this function:

## ◆ loadFromString()

template<typename _Tp >

static Ptr< _Tp > cv::Algorithm::loadFromString | ( | const String & | strModel,
|  | const String & | objname = String() )
| inline static

Loads algorithm from a String.

Parameters

  strModel | The string variable containing the model you want to load.
  objname | The optional name of the node to read (if empty, the first top-level node will be used)

This is static template method of Algorithm. It's usage is following (in the case of SVM):

Ptr<SVM> svm = Algorithm::loadFromString<SVM>(myStringModel);
cv::Algorithm::loadFromString
static Ptr< _Tp > loadFromString(const String &strModel, const String &objname=String())
Loads algorithm from a String.
Definition core.hpp:3215
Here is the call graph for this function:

## ◆ read() [1/2]

virtual void cv::Algorithm::read | ( | const FileNode & | fn | ) |
| inline virtual

Python:
| cv.Algorithm.read( | fn | ) -> | None

Reads algorithm parameters from a file storage.

Reimplemented in cv::aruco::ArucoDetector, cv::DescriptorMatcher, cv::face::BasicFaceRecognizer, cv::face::FaceRecognizer, cv::Feature2D, cv::FlannBasedMatcher, cv::legacy::Tracker, cv::line_descriptor::BinaryDescriptor, cv::optflow::GPCForest< T >, cv::optflow::GPCTree, and cv::saliency::StaticSaliencySpectralResidual.

## ◆ read() [2/2]

template<typename _Tp >

static Ptr< _Tp > cv::Algorithm::read | ( | const FileNode & | fn | ) |
| inline static

Python:
| cv.Algorithm.read( | fn | ) -> | None

Reads algorithm from the file node.

This is static template method of Algorithm. It's usage is following (in the case of SVM):

cv::FileStorage fsRead("example.xml", FileStorage::READ);
Ptr<SVM> svm = Algorithm::read<SVM>(fsRead.root());
cv::Algorithm::read
virtual void read(const FileNode &fn)
Reads algorithm parameters from a file storage.
Definition core.hpp:3158
cv::FileStorage
XML/YAML/JSON file storage class that encapsulates all the information necessary for writing or readi...
Definition persistence.hpp:261
cv::FileStorage::READ
@ READ
value, open the file for reading
Definition persistence.hpp:266

In order to make this method work, the derived class must overwrite Algorithm::read(const FileNode& fn) and also have static create() method without parameters (or with all the optional parameters)

## ◆ save()

virtual void cv::Algorithm::save | ( | const String & | filename | ) | const
| virtual

Python:
| cv.Algorithm.save( | filename | ) -> | None

Saves the algorithm to a file. In order to make this method work, the derived class must implement Algorithm::write(FileStorage& fs).

## ◆ write() [1/2]

virtual void cv::Algorithm::write | ( | FileStorage & | fs | ) | const
| inline virtual

Python:
| cv.Algorithm.write( | fs | ) -> | None
| cv.Algorithm.write( | fs, name | ) -> | None

Stores algorithm parameters in a file storage.

Reimplemented in cv::aruco::ArucoDetector, cv::bioinspired::Retina, cv::bioinspired::TransientAreasSegmentationModule, cv::DescriptorMatcher, cv::face::BasicFaceRecognizer, cv::face::FaceRecognizer, cv::Feature2D, cv::FlannBasedMatcher, cv::legacy::Tracker, cv::line_descriptor::BinaryDescriptor, cv::optflow::GPCForest< T >, cv::optflow::GPCTree, and cv::saliency::StaticSaliencySpectralResidual.

## ◆ write() [2/2]

void cv::Algorithm::write | ( | FileStorage & | fs,
|  | const String & | name ) const

Python:
| cv.Algorithm.write( | fs | ) -> | None
| cv.Algorithm.write( | fs, name | ) -> | None

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Here is the call graph for this function:

## ◆ writeFormat()

void cv::Algorithm::writeFormat | ( | FileStorage & | fs | ) | const
| protected

The documentation for this class was generated from the following file:

- opencv2/core.hpp